
import java.util.Scanner;

public class BinaryWeight {
	public static void main(String [] args) {
		Scanner input = new Scanner(System.in);
		
		int K = input.nextInt(); input.nextLine();
		long n; int i, j;

		for (int k = 0; k < K; k++) {
			n = input.nextLong(); input.nextLine();
			
			/*
			* Computes the next lexicographical permutation of the bits in n. Examples (in binary):
			* 0001 --> 0010
			* 0110 --> 1001
			* 1011 --> 1101
			*
			* Details of the algorithm:
			* 0. Take the rightmost 1...10...0 and reverse the string into 0...01...1.
			* 1. Take the leftmost 1 in this substring and swap it with the 0
			* immediately to the left of this substring.
			* Example: 1000111000 -> 1000000111 -> 1001000011.
			*/

			i = 0; // Number of rightmost bits processed
			while (((n >>> i) & 1) == 0) i++; // Skip over rightmost 0s
			j = 0; // Number of consecutive 1s to the left of rightmost consecutive 0s
			while (((n >>> i) & 1) == 1) { i++; j++; } // Count consecutive 1s
			n &= ~((1L << i) - 1); // Mask out lower bits
			n |= 1L << i; // Set relative leading 1
			n |= (1L << (j - 1)) - 1; // Set trailing 1s
			
			System.out.println(n);
		}
	}
}


