
import java.util.Scanner;

public class Cogwheels {
	public static void main(String [] args) {
		Scanner input = new Scanner(System.in);
		
		int K = input.nextInt(); input.nextLine();

		for (int k = 0; k < K; k++) {
			int n = input.nextInt();
			int m = input.nextInt(); input.nextLine();
			int[][] connections = new int[m][2]; // 0-based indexing
			for (int i = 0; i < m; i++) {
				connections[i][0] = input.nextInt() - 1;
				connections[i][1] = input.nextInt() - 1;
				input.nextLine();
			}
			// Propagate directions
			char[] directions = new char[n]; // 0-based indexing
			directions[0] = 'A'; // Clockwise
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					int a = connections[j][0];
					int b = connections[j][1];
					char dirA = directions[a];
					char dirB = directions[b];
					if (dirA == 0 ) directions[a] = oppositeDirection(dirB);
					else if (dirB == 0 ) directions[b] = oppositeDirection(dirA);
					else if (dirA == 'L') directions[b] = 'L';
					else if (dirB == 'L') directions[a] = 'L';
					else if (dirA == dirB) { directions[a] = directions[b] = 'L'; }
					// Else a and b do turn and have different directions, do nothing
				}
			}
			System.out.println("" + directions[1] + directions[2]);
		}
	}
	
	private static char oppositeDirection(char dir) {
		switch (dir) {
			case 0: return 0;
			case 'A': return 'B';
			case 'B': return 'A';
			case 'L': return 'L';
			default: throw new IllegalArgumentException();
		}
	}
}


