
import java.util.Scanner;

public class MaxValues {
	public static void main(String [] args) {
		Scanner input = new Scanner(System.in);
		final int WIDTH = 8; final int HEIGHT = 8;
		int K = input.nextInt(); input.nextLine();

		for (int k = 0; k < K; k++) {
			char[][] grid = new char[HEIGHT][WIDTH];
			for (int i = 0; i < HEIGHT; i++) {
				String line = input.nextLine();
				for (int j = 0; j < WIDTH; j++)
					grid[i][j] = line.charAt(j);
			}
			input.nextLine();// Discard line of hyphens
			// Dynamic programming
			int[][] value = new int[HEIGHT][WIDTH];
			for (int i = HEIGHT - 1; i >= 0; i--) {
				for (int j = 0; j < WIDTH; j++) {
					if (grid[i][j] == '#') value[i][j] = -1;
					else if (i == HEIGHT - 1 && j == 0) // Special case for bottom left
						value[i][j] = getValue(grid[i][j]);
					else {
						int temp = -1;
						if (i + 1 < HEIGHT)
						temp = Math.max(value[i + 1][j], temp);
						if (j - 1 >= 0)
						temp = Math.max(value[i][j - 1], temp);
						if (temp != -1)
						temp += getValue(grid[i][j]);
						value[i][j] = temp;
					}
				}
			}
			System.out.println(value[0][WIDTH - 1]);
		}
	}
	
	private static int getValue(char cell) {
		if (cell == '.')
			return 0;
		else if (cell == '#')
			return -1;
		else if (cell >= '0' && cell <= '9')
			return cell - '0';
		else
		throw new IllegalArgumentException();
}
}


